package jrummikub.view;

import jrummikub.util.IEvent;

/**
 * The player panel that contains a player's board and other user interfaces
 */
public interface IPlayerPanel {
  /**
   * @return the board where the players hand stones are displayed
   */
  public IBoard getBoard();

  /**
   * Sets the current player's name
   * 
   * @param playerName
   *          the player name
   */
  public void setCurrentPlayerName(String playerName);

  /**
   * Sets the time the player has left for his turn
   * 
   * @param time
   *          the time left
   */
  public void setTimeLeft(int time);

  /**
   * The sort by number event is emitted when the player wants to sort his
   * stones by number
   * 
   * @return the event
   */
  public IEvent getSortByNumberEvent();

  /**
   * The sort by number event is emitted when the player wants to sort his
   * stones by number
   * 
   * @return the event
   */
  public IEvent getSortByColorEvent();

  /**
   * The end turn event is emitted when the player wants to end his turn
   * 
   * @return the event
   */
  public IEvent getEndTurnEvent();
}
